<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SignalStrengthOutput StructType
 * @subpackage Structs
 */
class SignalStrengthOutput extends AbstractStructBase
{
    /**
     * The SignalStrengthAverage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $SignalStrengthAverage;
    /**
     * The SignalStrengthMin
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SignalStrengthMin;
    /**
     * The SignalStrengthMax
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SignalStrengthMax;
    /**
     * Constructor method for SignalStrengthOutput
     * @uses SignalStrengthOutput::setSignalStrengthAverage()
     * @uses SignalStrengthOutput::setSignalStrengthMin()
     * @uses SignalStrengthOutput::setSignalStrengthMax()
     * @param float $signalStrengthAverage
     * @param int $signalStrengthMin
     * @param int $signalStrengthMax
     */
    public function __construct($signalStrengthAverage = null, $signalStrengthMin = null, $signalStrengthMax = null)
    {
        $this
            ->setSignalStrengthAverage($signalStrengthAverage)
            ->setSignalStrengthMin($signalStrengthMin)
            ->setSignalStrengthMax($signalStrengthMax);
    }
    /**
     * Get SignalStrengthAverage value
     * @return float
     */
    public function getSignalStrengthAverage()
    {
        return $this->SignalStrengthAverage;
    }
    /**
     * Set SignalStrengthAverage value
     * @param float $signalStrengthAverage
     * @return \CustomerManagement\StructType\SignalStrengthOutput
     */
    public function setSignalStrengthAverage($signalStrengthAverage = null)
    {
        $this->SignalStrengthAverage = $signalStrengthAverage;
        return $this;
    }
    /**
     * Get SignalStrengthMin value
     * @return int
     */
    public function getSignalStrengthMin()
    {
        return $this->SignalStrengthMin;
    }
    /**
     * Set SignalStrengthMin value
     * @param int $signalStrengthMin
     * @return \CustomerManagement\StructType\SignalStrengthOutput
     */
    public function setSignalStrengthMin($signalStrengthMin = null)
    {
        // validation for constraint: int
        if (!is_null($signalStrengthMin) && !is_numeric($signalStrengthMin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($signalStrengthMin)), __LINE__);
        }
        $this->SignalStrengthMin = $signalStrengthMin;
        return $this;
    }
    /**
     * Get SignalStrengthMax value
     * @return int
     */
    public function getSignalStrengthMax()
    {
        return $this->SignalStrengthMax;
    }
    /**
     * Set SignalStrengthMax value
     * @param int $signalStrengthMax
     * @return \CustomerManagement\StructType\SignalStrengthOutput
     */
    public function setSignalStrengthMax($signalStrengthMax = null)
    {
        // validation for constraint: int
        if (!is_null($signalStrengthMax) && !is_numeric($signalStrengthMax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($signalStrengthMax)), __LINE__);
        }
        $this->SignalStrengthMax = $signalStrengthMax;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\SignalStrengthOutput
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
